/* $Id: disasm.h,v 1.1 1996/10/24 04:27:42 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	tAZuW[wb_
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */

#include	"include.h"

#define SXCALL_MAX	0x1000		/* SX Window use 0xa000 - 0xafff */

typedef enum {
	OTHER ,				/* ʂ̖ */
	JMPOP ,				/* 򖽗 */
	JSROP ,				/* Tu[`R[ */
	RTSOP ,				/* ^[ */
	BCCOP ,				/* 򖽗 */
	UNDEF = 15 ,		/* ` */
} opetype;


typedef enum {
	DregD ,				/* f[^WX^ */
	AregD ,				/* AhXWX^ */
	AregID ,			/* AhXWX^Ԑ */
	AregIDPI ,			/* |XgCNgAhXWX^Ԑ */
	AregIDPD ,			/* vfNgAhXWX^Ԑ */
	AregDISP ,			/* fBXv[XgtAhXWX^Ԑ */
	AregIDX ,			/* CfbNXtAhXWX^Ԑ */
	AbShort = 8 ,		/* ΃V[gAhX */
	AbLong ,			/* ΃OAhX */
	PCDISP ,			/* fBXv[XgtvOJE^ */
	PCIDX ,				/* CfbNXtvOJE^ */
	IMMED ,				/* C~fBGCgf[^ */
	SRCCR = 16 ,		/* CCR / SR ` */

	AregIDXB,			/* CfbNX&x[XfBXv[XgtAhXWX^Ԑ */
	AregPOSTIDX,		/* |XgCfbNXtԐ */
	AregPREIDX,			/* vCfbNXtԐ */
	PCIDXB,				/* CfbNX&x[XfBXv[XgtvOJE^Ԑ */
	PCPOSTIDX,			/* |XgCfbNXtPCԐ */
	PCPREIDX,			/* vCfbNXtPCԐ */

	CtrlReg,			/* 䃌WX^ */

	RegPairD,			/* WX^yA() dx:dy */
	RegPairID,			/* WX^yA(Ԑ) (rx):(ry) */
	BitField,			/* rbgtB[h {offset:width} */

	MMUreg,				/* MMUWX^ */

	FPregD,				/* FPn */
	FPCRSR,				/* FPSR,FPCR,FPIAR */
	FPPairD,			/* WX^yA() FPx:FPy */
	KFactor,			/* K-Factor {offset:width} */


} adrmode;


typedef struct {
	char			operand[ 64 ];	/* Iyh */
	adrmode			ea;				/* AhX[h */
	address			opval;			/* Iyh̒l */
	address			opval2;			/* Iyh̒l(odp) */
	address			eaadrs;			/* Iyh̑݃AhX */
	address			eaadrs2;		/* Iyh̑݃AhX(odp) */
	unsigned char	labelchange1;	/* x\ */
	unsigned char	labelchange2;	/* x\ */
	unsigned char	exbd;			/* bd ̃TCY(0,2,4)   0ȂTvX */
	unsigned char	exod;			/* od ̃TCY(0,2,4)   0ȂTvX */
	unsigned char	bsflag;	/* x[XWX^TvXĂ(1) łȂ(0) */
} operand;


typedef struct {
	char	opecode[ 32 ];	/*  */
	opesize	size;			/* TCY ( lea , pea  long ) ( 0 = .b .w .l .s nothing ) */
	opesize	size2;			/* TCY ( lea, pea, moveq, bset, ...  UNKNOWN ) */
	opesize	default_size;	/* ̖߂̃ftHg̃TCY */
	int		bytes;			/* ߂̃oCg */
	opetype	flag;			/* ߂̎ ( 0 = other jmp jsr rts bcc undef ) */
	address	jmp;			/* WvAhX ( 򖽗߂Ȃ ) */
	adrmode	jmpea;			/* AhX[h ( 򖽗߂Ȃ ) */
	operand	op1;
	operand	op2;
	operand	op3;
	operand	op4;
} disasm;


extern char		*OSlabel[ 0x100];
extern char		*FElabel[ 0x100];
extern char		*SXlabel[ SXCALL_MAX ];
extern char		OSCallName[ 16 ];
extern char		FECallName[ 16 ];
extern char		SXCallName[ 16 ];
extern boolean	Disasm_Exact;
extern boolean	Disasm_String;
extern boolean	Disasm_UnusedTrapUndefined;
extern boolean	Disasm_AddressErrorUndefined;
extern boolean	Disasm_MnemonicUpper;
extern boolean	Disasm_Dbra;
extern boolean	Disasm_MnemonicAbbreviation;
extern boolean	Disasm_SX_Window;

extern int		dis( address , disasm* , address* );
