/* $Id: disasmonly.c,v 1.1 1996/11/07 08:03:30 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	PȂtAZuW[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */

#include	<stdio.h>
#include	<string.h>	/* strcmp memcmp strlen */
#include	<ctype.h>	/* tolower */
#include	"estruct.h"
#include	"global.h"
#include	"disasm.h"
#include	"generate.h"
#include	"output.h"
#include	"hex.h"
#include	"etc.h"

USEOPTION	option_x , option_U;

/* static ֐vg^Cv */
private int	disasm1line( address );


/*

 PȂtAZu

*/
extern void	disasmlist( xfilename , sfilename , filedate )
char	*xfilename , *sfilename;
time_t	filedate;
{
	address	pc = BeginTEXT;
	char	adrs[8];

	if( option_x )
	Atab += 2;

	init_output();
	output_file_open( sfilename , 0 );

#ifdef	OSKDIS
	while( pc < BeginBSS ) {
		itox6( adrs , (ULONG)pc );
		outputa( adrs );
		pc += disasm1line( pc );
	}
#else
	while( pc < BeginDATA ) {
	itox6( adrs , (ULONG)pc );
	outputa( adrs );
	pc += disasm1line( pc );
	}
#endif	/* OSKDIS	*/

	output_file_close();
}


private int	disasm1line( pc )
address	pc;
{
	static char	*size[2][10] = {
		".b" , ".w" , ".l" , ".q" , ".s" , ".s" , ".d" , ".x" , ".p" , "" ,
		".B" , ".W" , ".L" , ".Q" , ".S" , ".S" , ".D" , ".X" , ".P" , ""
	};
	char	buffer[256];
	address	store , store0, pc0;
	disasm	code;
	int		iocsno;
	int		bytes;

	buffer[0] = '\0';
	pc0 = pc;
	store = pc + Ofst;
	store0 = store;
	store += bytes = dis( store , &code , &pc );

	labelchange( &code , &code.op1 );
	labelchange( &code , &code.op2 );
	labelchange( &code , &code.op3 );
	labelchange( &code , &code.op4 );

	if( code.flag == OTHER &&
	*(UBYTE*)store0 == 0x70 &&			/* 0x70xx == moveq.l #xx,d0 */
	*(UWORD*)store == 0x4e4f &&			/* 0x4e4f == TRAP #15 opecode */
	IOCSlabel[ iocsno = (int)*(UBYTE*)( store0 + 1 ) ] ) {
		strcpy( buffer , "\tIOCS\t" );
		strcat( buffer , IOCSlabel[ iocsno ] );
		store += 2;
		pc += 2;
		bytes += 2;
	} else {
		strcat( buffer , "\t" );
		strcat( buffer , code.opecode );
		strcat( buffer , size[ (int)option_U ][ code.size ] );
		if( code.op1.operand[0] ) {
			strcat( buffer , "\t" );
			strcat( buffer , code.op1.operand );
		}
		if( code.op2.operand[0] ) {
			if( code.op2.ea != BitField && code.op2.ea != KFactor )
				strcat( buffer , "," );
			strcat( buffer , code.op2.operand );
		}
		if( code.op3.operand[0] ) {
			if( code.op3.ea != BitField && code.op3.ea != KFactor )
				strcat( buffer , "," );
			strcat( buffer , code.op3.operand );
		}
		if( code.op4.operand[0] ) {
			if( code.op4.ea != BitField && code.op4.ea != KFactor )
				strcat( buffer , "," );
			strcat( buffer , code.op4.operand );
		}
	}

	if( option_x )
	byteout_for_xoption( pc0 , store - store0 , buffer );

	outputa( buffer );
	newline( store0 - Ofst );

	if( code.flag == RTSOP ||
	code.flag == JMPOP && tolower( code.opecode[0] ) == 'j' )	/* RTŠɂ͋s */
	outputa( CR );

	return bytes;
}
