/* $Id: estruct.h,v 1.1 1996/10/24 04:27:44 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	\̒`t@C
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */


/* #include	<class.h> */
typedef unsigned char	UBYTE;
typedef	short			WORD;
typedef	unsigned short	UWORD;
typedef	long			LONG;
typedef	unsigned long	ULONG;


#ifdef	OSKDIS
#ifdef	TRUE
#undef	TRUE
#endif
#ifdef	FALSE
#undef	FALSE
#endif
#endif	/* OSKDIS	*/
typedef enum { FALSE , TRUE } boolean;

typedef enum {
	BYTESIZE ,		/* oCg */
	WORDSIZE ,		/* [h */
	LONGSIZE ,		/* O[h */
	QUADSIZE ,		/* Nbh[h */
	SHORTSIZE ,		/* V[g( Ε򖽗 ) */

	SINGLESIZE ,	/* 32bit^ */
	DOUBLESIZE ,	/* 64bit^ */
	EXTENDSIZE ,	/* 96bit^ */
	PACKEDSIZE ,	/* 96bitBCD^ */
	NOTHING ,		/*  */

	STRING ,		/*  */
	RELTABLE ,		/* P[^uItZbge[u */
	RELLONGTABLE ,	/* O[hȃP[^uItZbge[u */
	ZTABLE ,		/* ΔԒne[u */
#ifdef	OSKDIS
	WTABLE ,		/* [he[u	*/
#endif	/* OSKDIS	*/

	EVENID ,
	CRID ,
	WORDID ,
	LONGID ,
	BYTEID ,
	ASCIIID ,
	ASCIIZID ,
	LASCIIID ,
	BREAKID ,
	ENDTABLEID ,
	UNKNOWN	= 128		/* s */
} opesize;


typedef UBYTE*	address;


typedef struct {		/* .x t@C̃wb_ */
	char	head[4];
	address	base;
	address	exec;
	ULONG	text;
	ULONG	data;
	ULONG	bss;
	ULONG	offset;
	ULONG	symbol;
	char	reserve[ 0x1c ];
	ULONG	bindinfo;
} xheader;

#ifdef	OSKDIS
typedef struct {		/* OS-9/680x0 W[̃wb_	*/
	UWORD	head;		/* +00 $4AFC						*/
	UWORD	sysrev;		/* +02 rWhc				*/
	ULONG	size;		/* +04 W[TCY				*/
	ULONG	owner;		/* +08 I[ihc					*/
	address	name;		/* +0C W[ItZbg		*/
	UWORD	accs;		/* +10 ANZX					*/
	UWORD	type;		/* +12 W[^Cv^		*/
	UWORD	attr;		/* +14 ^rW				*/
	UWORD	edition;	/* +16 GfBV					*/
	address	usage;		/* +18 gRg̃ItZbg	*/
	address	symbol;		/* +1C V{e[u				*/
	char	resv[14];	/* +20 \ς						*/
	UWORD	parity;		/* +2E wb_peB				*/
	address	exec;		/* +30 sItZbg				*/
	address	excpt;		/* +34 [UgbvGg		*/
	ULONG	mem;		/* +38 TCY					*/
	ULONG	stack;		/* +3C X^bNTCY				*/
	address	idata;		/* +40 f[^ItZbg		*/
	address	irefs;		/* +44 QƃItZbg			*/
	address	init;		/* +48 sGg(TRAPLIB)	*/
	address	term;		/* +4C IsGg(TRAPLIB)	*/
} os9header;
#endif	/* OSKDIS	*/

