/* $Id: hex.h,v 1.1 1996/10/24 04:27:46 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	16iϊ , String ֐ wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include	"global.h"

USEOPTION	option_Z;

#define	itox8( ptr , num )	itox( ptr , num , 8 )
#define	itox4( ptr , num )	itox( ptr , num , 4 )

#define	itox8d( ptr , num )	itoxd( ptr , num , 8 )
#define	itox4d( ptr , num )	itoxd( ptr , num , 4 )
#define	itox2d( ptr , num )	itoxd( ptr , num , 2 )


INLINE char	*strend( char* );

extern char	*itod2( char* , ULONG );		/* 蔲 */


extern char	*itox( char* , ULONG , int );
extern char	*itox6_without_0supress( char* , ULONG );
extern char	*itox4_without_0supress( char* , ULONG );
INLINE char	*itox6d( char* , ULONG );
INLINE char	*itox6( char* , ULONG );
INLINE char	*itox2( char* , ULONG );
INLINE char	*itox2_without_0supress( char* , ULONG );

extern char	Hex[16];
extern int	Zerosupress_mode;


#ifdef	__GNUC__
inline static char	*strend( ptr )
char	*ptr;
{
    while( *ptr++ )
	;
    return --ptr;
}


inline static char	*itox2( buf , num )
char	*buf;
ULONG	num;
{
    if( !option_Z || num >= 0x10 ) {
	buf[1] = Hex[ num & 0xf ];
	buf[0] = Hex[ ( num >> 4 )& 0xf ];
	buf[2] = '\0';
	return buf + 2;
    }
    buf[0] = Hex[ num & 0xf ];
    buf[1] = '\0';
    return buf + 1;
}


inline static char	*itox2_without_0supress( buf , num )
char	*buf;
ULONG	num;
{
    buf[1] = Hex[ num & 0xf ];
    buf[0] = Hex[ ( num >> 4 )& 0xf ];
    buf[2] = '\0';
    return buf + 2;
}


inline static char	*itoxd( buf , num , width )
char	*buf;
ULONG	num;
int	width;
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return( width == 2 ? itox2( buf , num ) : itox( buf , num , width ) );
}


inline static char	*itox6( buf , num )
char	*buf;
ULONG	num;
{
    return itox( buf , num , ( num >= 0x1000000 ? 8 : 6 ) );
}


inline static char	*itox6d( buf , num )
char	*buf;
ULONG	num;
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return itox6( buf , num );
}
#endif	/* __GNUC__ */

