/* $Id: search.c,v 1.1 1996/11/07 08:03:58 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	񔻒
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include	<stdio.h>
#include	<string.h>
#ifdef	OSK
#include	<kanji.h>	/* iskanji, etc.	*/
#endif	/* OSK	*/
#ifndef unix
#	ifdef MYU_HEADERS
#		include	<jctype.h>
#	else
#		include	<jfctype.h>
#	endif
#else
#	include <jctype.h>
#	include	<ctype.h>
#endif

#include	"estruct.h"
#include	"global.h"
#include	"label.h"	/* regist_label etc. */
#include	"offset.h"	/* depend_address , nearadrs */
#include	"etc.h"		/* charout */

/* private ֐vg^Cv */
private boolean	is_string( address , address , address* , int );
private int	check_data_area( address , address , int );
private void	foundstr( address , address );


/*#define	DEBUG*/

/*

  T[`
  ƂĔFԂ

*/
extern int	search_string( str_min )
int	str_min;
{
    lblbuf	*nadrs;
    lblmode	mode , nmode;
    address	pc , nlabel;
    int		num_of_str = 0;

    nadrs = next( BeginTEXT );

    pc = nadrs->label;	/* ŏ */
    nmode = nadrs->mode;
    while( pc < BeginBSS ) {
	charout( '.' );
	mode = nmode;
/*	nadrs = next( pc + 1 );*/
	nadrs = Next( nadrs );
	nlabel = nadrs->label;
	nmode = nadrs->mode;

	if( isDATLABEL( mode ) && ( mode & 0xff ) == UNKNOWN )
	    num_of_str += check_data_area( pc , nlabel , str_min );

	pc = nlabel;
    }
    return num_of_str;
}


/*

  pc  nlabel ܂ł̃f[^̈撆̕`FbN

*/
private int	check_data_area( pc , nlabel , str_min )
address	pc , nlabel;
int	str_min;
{
    address	ltemp , nlabel2;
    int		num_of_str = 0;

#ifdef	DEBUG
    printf( "* check_data_area %x - %x \n" , pc , nlabel );
#endif
    while( pc < nlabel ) {
	nlabel2 = ltemp = (address)min( (ULONG)nearadrs( pc ) , (ULONG)nlabel );
	while( pc < nlabel2 ) {
	    if( is_string( pc , ltemp , &ltemp , str_min ) ) {
		foundstr( pc , ltemp );
		num_of_str++;
		while( depend_address( ltemp ) && ltemp + 4 <= nlabel2 )
		    ltemp += 4;
		regist_label( ltemp , DATLABEL | UNKNOWN );
		pc = ltemp;
		ltemp = (address)min( (ULONG)nearadrs( pc ) , (ULONG)nlabel );
	    } else
		pc = nlabel2;
	}
	while( depend_address( pc ) )
	    pc += 4;
    }
    return num_of_str;
}


private void	foundstr( pc , ltemp )
address	pc , ltemp;
{
    charout( 's' );
#ifdef	DEBUG
    printf( "    * FOUND STRING AT %x - %x \n" , pc , ltemp );
#endif
    regist_label( pc , DATLABEL | STRING );
}


/*

  񂩂ǂ𒲂ׂ
  *newend = last string address

*/
private boolean	is_string( from , end , newend , str_min )
address	from , end;
address	*newend;
int	str_min;
{
    address	store;

#ifdef	DEBUG
    printf( "  * is_string %x - %x\n" , from , end );
#endif

    *newend = end;
    store = from + Ofst;

    while( store - Ofst < end ) {
		if( *store == 0x80 ) {			/* pЂ炪 */
		    if( *( store + 1 ) < 0x86 || 0xfc < *( store + 1 ) ) {
			return FALSE;
		    } else
			store += 2;
		} else if( iskanji( *store ) ) {	/* Sp */
		    if( !iskanji2( *( store + 1 ) ) ) {
			return FALSE;
		    } else
			store += 2;
		} else if( isprkana( *store ) ) {	/* ANK  */
		    store++;
		} else {
		    switch( *store ) {
		    case 0x07:
		    case 0x09:
		    case 0x0d:
		    case 0x0a:
		    case 0x1a:
		    case 0x1b:
				store++;
				break;
		    case 0x00:
				if( from + str_min <= store - Ofst ) {
				    store++;
				    while( store - Ofst < end && !*store )
					store++;
				    *newend = (address)min( (ULONG)( store - Ofst ) , (ULONG)end );
				    return TRUE;
				}
				return FALSE;
		    default:
				return FALSE;
		    }
		}
    }
    if( from + str_min <= store - Ofst ) {
		*newend = (address)min( (ULONG)( store - Ofst ) , (ULONG)end );
		return TRUE;
    }
    return FALSE;
}

