/* $Id: hex.c,v 1.1 1996/11/07 08:03:40 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	16iϊ , String ֐
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */

#include <string.h>		/* strcpy */
#include "estruct.h"
#include "hex.h"

char	Hex[16] = "0123456789abcdef";
int	Zerosupress_mode = 0;


/* 蔲 ^^; */
extern char	*itod2( buf , num )
char	*buf;
ULONG	num;
{
	int i;

	i = num % 100;

	if( i/10 )
		*buf++ = i/10 + '0';
	*buf++ = num % 10 + '0';

	*buf = '\0';
	return buf;
}



extern char	*itox( buf , num , width )
char	*buf;
ULONG	num;
int	width;
{
    int		i;
    
    if( option_Z ) {
	char	buffer[9];
	
	if( num != 0 ) {
	    buffer[8] = '\0';
	    for( i = 7 ; i >= 0 && num != 0 ; i-- ) {
		buffer[ i ] = Hex[ num & 0xf ];
		num >>= 4;
	    }
	    strcpy( buf , buffer + i + 1 );
	    return buf + 7 - i;
	} else {
	    *buf++ = '0';
	    *buf   = '\0';
	    return buf;
	}
    }
    
    for( i = width - 1 ; i >= 0 ; i-- ) {
	buf[ i ] = Hex[ num & 0xf ];
	num >>= 4;
    }
    buf[ width ] = '\0';
    return buf + width;
}


extern char	*itox6_without_0supress( buf , num )
char	*buf;
ULONG	num;
{
    int		i;
    
    for( i = 5 ; i >= 0 ; i-- ) {
	buf[ i ] = Hex[ num & 0xf ];
	num >>= 4;
    }
    buf[6] = '\0';
    return buf + 6; 
}


extern char	*itox4_without_0supress( buf , num )
char	*buf;
ULONG	num;
{
    int		i;
    
    for( i = 3 ; i >= 0 ; i-- ) {
	buf[ i ] = Hex[ num & 0xf ];
	num >>= 4;
    }
    buf[4] = '\0';
    return buf + 4;
}


#ifndef	__GNUC__

extern char	*strend( ptr )
char	*ptr;
{
    while( *ptr++ )
	;
    return --ptr;
}


extern char	*itox2_without_0supress( buf , num )
char	*buf;
ULONG	num;
{
    buf[1] = Hex[ num & 0xf ];
    buf[0] = Hex[ ( num >> 4 )& 0xf ];
    buf[2] = '\0';
    return buf + 2; 
}


extern char	*itox2( buf , num )
char	*buf;
ULONG	num;
{
    if( !option_Z || num >= 0x10 ) {
	buf[ 1 ] = Hex[ num & 0xf ];
	buf[ 0 ] = Hex[ ( num >> 4 )& 0xf ];
	buf[ 2 ] = '\0';
	return buf + 2;
    }
    buf[ 0 ] = Hex[ num & 0xf ];
    buf[ 1 ] = '\0';
    return buf + 1;
}


extern char	*itoxd( buf , num , width )
char	*buf;
ULONG	num;
int		width;
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return( width == 2 ? itox2( buf , num ) : itox( buf , num , width ) );
}


extern char	*itox6d( buf , num )
char	*buf;
ULONG	num;
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return itox6( buf , num );
}


extern char	*itox6( buf , num )
char	*buf;
ULONG	num;
{
    return itox( buf , num , ( num >= 0x1000000 ? 8 : 6 ) );
}
#endif	/* __GNUCC__ */
