/* $Id: label.h,v 1.1 1996/10/24 04:27:48 ryo freeze $
 *
 *		\[XR[hWFl[^
 *		xǗW[wb_
 *		Copyright (C) 1989,1990 K.Abe
 *		All rights reserved.
 *
 */


typedef enum {
	PROLABEL =	0 , 					/* vO */
	DATLABEL =	0x10000 ,				/* f[^ */
	FORCE	 =	0x20000 ,				/* tO */
	HIDDEN	 =	0x40000 ,				/* 1 Ȃ炻̃x̓\[XɌȂ */
	TABLE	 =	0x80000 ,				/* 1 Ńe[uJn */
#ifdef	OSKDIS
	ENDTABLE =	0x100000 ,				/* 1 Ńe[uI */
	CODEPTR	 =	0x400000 ,				/* 1 ŃR[h|C^ */
	DATAPTR	 =	0x800000				/* 1 Ńf[^|C^ */
#else
	ENDTABLE =	0x100000				/* 1 Ńe[uI */
#endif	/* OSKDIS	*/
} lblmode;


struct _avl_node;
typedef struct {
	address 			label;			/* AhX */
	struct _avl_node	*avl;			/* AVL-tree-library side node */
	lblmode 			mode;			/*  */
	short				shift;			/*  */
	unsigned short		count;			/* o^ */
} lblbuf;


/*

  lblmode		ʂWrbg	Iy[VTCY(f[^x݈̎̂Ӗ)
				16rbg		0...PROLABEL	1...DATLABEL
				17rbg		0...				1...
  shift 		xAhXƂ̂.ʏO.
				߂̃IyhɃx肷...

*/


extern void 	init_labelbuf(void);
extern void 	free_labelbuf(void);
extern boolean	regist_label(address adrs, lblmode mode);
extern void 	unregist_label(address adrs);
extern lblbuf	*search_label(address adrs);
extern lblbuf	*next(address adrs);
extern lblbuf	*Next(lblbuf *);
extern lblbuf	*next_prolabel(address adrs);
extern lblbuf	*next_datlabel(address adrs);
extern int		get_Labelnum(void);

#define isPROLABEL(a)	(!((a) & DATLABEL))
#define isDATLABEL(a)	((a) & DATLABEL)
#define isHIDDEN(a) 	((a) & HIDDEN)
#define isTABLE(a)		((a) & TABLE)
#define isENDTABLE(a)	((a) & ENDTABLE)
