char RCSid[] = "$Id: main.c,v 2.76 1995/01/07 11:32:22 ryo Exp $";
/*
 *		\[XR[hWFl[^
 *		C[`
 *		Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *		All rights reserved.
 *
 */


#include		<stdio.h>
#include		<string.h>		/* memcmp */
#include		<limits.h>		/* PATH_MAX */

#ifdef LIBC
#define __DOS_INLINE__
#include		<sys/dos.h>
#endif


#ifndef unix
#include		<io.h>			/* access */
#include		<conio.h>		/* getche */
#ifndef MYU_HEADERS
		#include		<fcntl.h>		/* open */
		#include		<stat.h>		/* open fstat */
#endif
#else
#include		<conio.h>
#include		<unistd.h>
#include		<sys/types.h>
#include		<sys/stat.h>
#include		<sys/file.h>
#ifndef LIBC
#define 		O_BINARY		0
#endif
#endif
#include		<stdlib.h>		/* exit */
#include		<ctype.h>		/* tolower */
#include		<time.h>		/* time difftime */
#include		"estruct.h"
#include		"global.h"
#include		"etc.h"
#include		"labelfile.h"
#include		"label.h"
#include		"analyze.h"
#include		"option.h"
#include		"offset.h"
#include		"symbol.h"
#include		"disasm.h"
#include		"generate.h"
#include		"table.h"
#include		"include.h"



USEOPTION		option_g , option_e , option_v , option_d , option_i ,
				option_p , option_l , option_p , option_c , option_z , option_D ,
				option_T , option_t;

USEOPTION		option_overwrite;


extern int		main( int , char*[] );
extern void 	free_load_buffer( void );

/* static ֐vg^Cv */
private void	analyze_and_generate( int , char*[] );
private address loadfile( char* );
private void	analyze_device( void );
private void	check_exist_output_file( char* );
private void	check_open_output_file( char* );


/*#define		DEBUG*/

xheader Head;
#ifdef	OSKDIS
os9header	HeadOSK;
#endif	/* OSKDIS	*/
ULONG	Top;					/* ۂɃt@ĈAhX */
ULONG	Ofst;					/* ۂ̃AhX - zAhX */

/********************************************
  Human68K pi-DOSKDIS j̏ꍇ́A
    BeginTEXT = text section ̐擪
    BeginDATA = data section ̐擪
    BeginBSS  = bss section ̐擪
  OS-9/680x0 pi-DOSKDIS Lj̏ꍇ́A
    BeginTEXT = psect 擪
    BeginDATA =  vsect 擪
    BeginBSS  = vsect 擪
*********************************************/
address BeginTEXT ,
		BeginDATA ,
		BeginBSS ,
		Last;
address Available_text_end; 	/* = BeginDATA or BeginBSS */
int 	Absolute;				/* ΔԒn`[h
								   NOT_ABSOLUTE , ABSOLUTE_ZFILE , ABSOLUTE_ZOPT */

int 	Debug = 0;

int 	Verbose = 1;
int 	UndefRegLevel = 1+2+4+8;
int 	Quiet_mode = 0;
char CommentChar = ';';


/* common with option.c */
short	MPU_context = 30;				/* ŏ̃ReNXg 030 */
short	MPU_type = 30;					/* ftHg MC68030 */
short	MMU_type = 0;					/* 68851 (68020) ftHgŖT|[g */
short	FPCP_type = 0;					/* 68881/882 ftHgŖT|[g */

/* ̓Y͈ӖȂB RvID * 2 = Y (r̎̃VtgȂ )*/
short	FPCP_ID[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


int 	String_length_min = 3;	/* ̍ŏ */
char	Labelfilename_in[PATH_MAX];
char	Labelfilename_out[PATH_MAX];
char	Tablefilename[PATH_MAX];
char	Filename[2][PATH_MAX];
address Base;					/* [hAhX */
address Exec;					/* sJnAhX */
boolean Exist_symbol;			/* V{e[ȗ݃tO */

static time_t	Filedate;


extern int		main( argc , argv )
int 	argc;
char	*argv[];
{
	time_t		start_time , finish_time;

	start_time = time( NULL );

#ifdef	OSK
	setbuf(stderr, 0);	/* stderr ̓obt@OȂ	*/
	setbuf(stdout, 0);	/* stdout ̓obt@OȂ	*/
#endif	/* OSK	*/
	setbuf( stderr , NULL );

#ifdef	OSKDIS
    fprintf( stderr , "\[XR[hWFl[^ for OS-9/68000 version %s\n" , Version );
    fprintf( stderr , "Copyright (C) 1989-1992 K.Abe\n" );
    fprintf( stderr , "OS-9/68000 version by TEMPLE, 1994\n" );
#else
	fprintf( stderr , "\[XR[hWFl[^ for X680x0 version %s\n" , Version );
	fprintf( stderr , "Copyright (C) 1989-1992 K.Abe , 1994-1997 R.ShimiZu\n" );
#endif	/* OSKOSK	*/

	Absolute = NOT_ABSOLUTE;
	analyze_args( argc , argv );

	fprintf( stderr , "%s ǂݍ݂܂.\n" , Filename[0] );

	/* AhX֌W̑ϐ */
	Top = (ULONG)loadfile( Filename[0] );
	Ofst = Top - (ULONG)Head.base;
	BeginTEXT = Head.base;
#ifdef	OSKDIS
    BeginBSS = BeginTEXT + Head.text;
    BeginDATA = BeginBSS + Head.bss;
    Last      = BeginDATA + Head.data;
/*    Available_text_end = ( option_D ? BeginBSS : BeginDATA );	*/
    Available_text_end = BeginBSS;

#else
	BeginDATA = BeginTEXT + Head.text;
	BeginBSS  = BeginDATA + Head.data;
	Last	  = BeginBSS  + Head.bss;
	Available_text_end = ( option_D ? BeginBSS : BeginDATA );

	if( Head.bindinfo ) {
		fprintf( stderr, "̃t@C bind Ă܂.\n" );
		fprintf( stderr, "bindR}hœWJĂ\[XWFl[gĉ.\n" );
		exit( 1 );
	}
#endif	/* OSKDIS	*/

#ifdef	OSKDIS
	fprintf( stderr, "os9defs.d mathdefs.d ciodefs.d ǂݍ݂܂.\n");
#else
	fprintf( stderr , "doscall.mac iocscall.mac fefunc.h ǂݍ݂܂.\n" );
#endif	/* OSKDIS	*/
	load_OS_sym();
	init_labelbuf();
	init_symtable();

	fprintf( stderr , "Target MPU :MC680%02d\n" , MPU_type );
	if( FPCP_type ){
		int i=0;

		fprintf( stderr , "Target FPCP:" );

		if( (FPCP_type & 1) || ( FPCP_type & 2 ) ){
			fprintf( stderr, "MC68881/882");	i=1;
		}
		if( FPCP_type & 4 ){
			if( i )	fprintf( stderr, ",");
			fprintf( stderr, "MC68040");	i=1;
		}

		fprintf( stderr, "\n");
	}

#ifndef	OSKDIS
    fprintf( stderr , "P[gWJ܂.\n" );
	make_relocate_table();
#endif	/* !OSKDIS	*/


	check_exist_output_file( Filename[1] );
	if( option_e )
		check_exist_output_file( Labelfilename_out );
	check_open_output_file( Filename[1] );

	if( option_g ) {
		fprintf( stderr , "xt@Cǂݍݒł.\n" );
		read_labelfile( Labelfilename_in );
	}
	if( option_e )
		check_open_output_file( Labelfilename_out );
	if( option_T ) {
		fprintf( stderr , "e[uLqt@Cǂݍݒł.\n" );
		read_tablefile( Tablefilename );
	}

#ifndef	OSKDIS
	if( !option_g ) {
		if( Head.symbol ) {
			fprintf( stderr , "V{e[uWJ܂.\n" );
			make_symtable();
		} else
			fprintf( stderr , "V{e[u͎cOȂ瑶݂܂.\n" );
	}
#endif	/* OSKDIS	*/

	Exist_symbol = is_exist_symbol();

	analyze_and_generate( argc , argv );

	fprintf( stderr , "\nI܂.\n" );
	free_labelbuf();
	free_relocate_buffer();
	free_symbuf();
	free_load_buffer();

	finish_time = time( NULL );

	fprintf( stderr , "v: %db\n" , (int)difftime( finish_time , start_time ) );
		return(0);
}


/*

  ͂Đ

*/
private void	analyze_and_generate( argc , argv )
int 	argc;
char	*argv[];
{
	if( option_v ) {
		fprintf( stderr , "tAZuXgo͂܂.\n" );
		disasmlist( Filename[0] , Filename[1] , Filedate );
		return;
	}

	Disasm_String = FALSE;		/* ͒̓j[jbN͕sv */
	if( !option_g ) {
#ifdef	OSKDIS
		switch(HeadOSK.type & 0x0F00) {
			case 0x0100:	/* Program */
			case 0x0b00:	/* Trap */
				fprintf( stderr, "\nf[^̈͒ł.");
				analyze_idata();	/* f[^ItZbg	*/
				analyze_irefs();	/* f[^Qƃe[u	*/
				fprintf( stderr, "\n");
			default:
				break;
		}
		regist_label( Head.base + Head.text + Head.data + Head.bss, DATLABEL | UNKNOWN );
#endif	/* OSKDIS	*/
		fprintf( stderr , "vÖ͒ł." );
		/* ZNṼGgAhXe[uɓo^ */
		regist_label( BeginTEXT , DATLABEL | UNKNOWN );
		regist_label( BeginDATA , DATLABEL | UNKNOWN );
		regist_label( BeginBSS	, DATLABEL | UNKNOWN );
		regist_label( Last		, DATLABEL | UNKNOWN );
		Reason_verbose = ( Verbose >= 1 ? TRUE : FALSE );
#ifdef	OSKDIS
	switch(HeadOSK.type & 0x0F00) {
		case 0x0b00:	/* Trap */
			regist_label( HeadOSK.init, PROLABEL | WORDSIZE | FORCE );
			regist_label( HeadOSK.term, PROLABEL | WORDSIZE | FORCE );
			z_table(0x000048);
		case 0x0100:	/* Program */
#if	1	/* fobÖׂ̃R[h	*/
			regist_label( HeadOSK.idata, DATLABEL | LONGSIZE | FORCE );
			regist_label( HeadOSK.irefs, DATLABEL | WORDSIZE | FORCE );
#endif
			break;
		case 0x0200:	/* Subroutine	*/
		case 0x0c00:	/* System */
			break;
		case 0x0d00:	/* FileMan */
			regist_label( HeadOSK.exec + 0 , DATLABEL | WORDSIZE | FORCE );
			relative_table(HeadOSK.exec);
			break;
		case 0x0e00:
			regist_label( HeadOSK.exec + 0 , DATLABEL | WORDSIZE | FORCE );
			w_table(HeadOSK.exec);
			break;
	}
	regist_label( HeadOSK.excpt, PROLABEL | WORDSIZE | FORCE );
	regist_label( HeadOSK.name, DATLABEL | STRING | FORCE );
#if	1
	regist_label( HeadOSK.size-4, DATLABEL | BYTESIZE | FORCE );	/* CRC */
#endif
	analyze( Head.exec , ANALYZE_IGNOREFAULT );
#else
		if( option_d ) {
		    analyze_device();
		    if( Head.exec != Head.base )
				analyze( Head.exec , option_i ? ANALYZE_IGNOREFAULT : ANALYZE_NORMAL );
		} else
		    analyze( Head.exec , ANALYZE_IGNOREFAULT );
#endif	/* OSKDIS	*/
	}

	Reason_verbose = ( Verbose == 2 ? TRUE : FALSE );
	fprintf( stderr , "\nf[^̈͒ł." );
	analyze_data();
/*
	if( !option_g && !option_t ) {
		fprintf( stderr , "\nAhXe[u{Ă܂." );
		search_adrs_table();
	}
*/
	if( !option_p )
		do {
			fprintf( stderr , "\nf[^̈̒vÖ{Ă܂(1)." );
		} while( research_data() && !option_l );

	if( String_length_min != 0 )
		do {
			fprintf( stderr , "\n{Ă܂\n" );
			if( !search_string( String_length_min ) || option_p )
				break;
			if( !option_q )
				fputc( '\n' , stderr );
			fprintf( stderr , "f[^̈̒vÖ{Ă܂(2)." );
			if( !research_data() )
				break;
			do {
				fprintf( stderr , "\nf[^̈̒vÖ{Ă܂." );
			} while( research_data() && !option_l );
		} while( !option_l );

	if( option_e ) {
		fprintf( stderr , "\nxt@C쐬ł." );
		make_labelfile( Filename[0] , Labelfilename_out );
	}

	if( !option_c ) {
		fprintf( stderr , "\nx`FbN." );
		search_operand_label();
	}

	fprintf( stderr , "\[X쐬ł." );
	generate( Filename[0] , Filename[1] , Filedate , argc , argv );
}


/*

  t@Cǂݍ݁Awb_ϐ Head ɃZbg
  t@C̓t Filedate ɃZbg
  ǂݍ񂾐擪AhXԂ

*/
private address loadfile( filename )
char	*filename;
{
	int 		handle;
	address 	top;
	char		ext[NAME_MAX];
	ULONG		bytes;
	struct stat statbuf;
	struct {
		UWORD	header;
		ULONG	text;
		ULONG	data;
		ULONG	bss;
		char	reserve[8];
		address base;
		UWORD	pudding;
	} zhead;

	{
		char *p;
		p = rindex( filename, '.' );
		if( p )
			strcpy( ext, p+1 );
		else
			ext[0] = '\0';
	}


#ifdef	OSK
	if( ( handle = open( filename , S_IREAD )) <= 0 )
		err( 1 , "%sI[vo܂\n" , filename );
#else
	if( ( handle = open( filename , O_BINARY | O_RDONLY , S_IRUSR )) <= 0 )
		err( 1 , "%sI[vo܂\n" , filename );
#endif	/* OSK	*/

	if( fstat( handle , &statbuf ) < 0 )
		err( 1 , "fstat failed.\n" );
	Filedate = statbuf.st_mtime;

#ifdef	OSKDIS
    if( option_z ) {
		Head.base = Base;
		Head.exec = Exec;
		Head.text = statbuf.st_size;
		Head.data = 0;
		Head.bss = 0;
		Head.symbol = 0;
		Head.bindinfo = 0;
    } else {
		read( handle , (char *)&HeadOSK , 0x0050 );
		if (HeadOSK.head != 0x4AFC) {
			fprintf(stderr, "ID=%04X\n", HeadOSK.head);
			close(handle);
			err(1, "%s  OS-9/680x0 ̃W[ł͂܂.\n", filename);
		}
		switch (HeadOSK.type & 0x0F00) {
			case 0x0100:	/* Program */
				Head.base = 0x0048;
				Head.bss = HeadOSK.mem;
				break;
			case 0x0b00:	/* Trap */
				Head.base = 0x0048;
				Head.bss = HeadOSK.mem;
				break;
			case 0x0200:	/* Subroutine	*/
			case 0x0c00:	/* System */
			case 0x0d00:	/* FileMan */
			case 0x0e00:	/* Driver */
				Head.base = 0x003C;
				Head.bss = HeadOSK.mem;
				break;
			default:
				close(handle);
				err(1, "̃W[^Cv̓T|[gĂ܂.\n");
		}
		lseek(handle, Head.base, 0);
		Head.exec = HeadOSK.exec;
		Head.text = statbuf.st_size - (ULONG)(Head.base);
		Head.data = 0;
		Head.symbol = 0;
		Head.bindinfo = 0;
    }
#else
	if( option_z || strcmpi( ext , "r" ) == 0 ) {
		Head.base = Base;
		Head.exec = Exec;
		Head.text = statbuf.st_size;
		Head.data = 0;
		Head.bss = 0;
		Head.symbol = 0;
		Head.bindinfo = 0;
	} else if( strcmpi( ext , "z" ) == 0 ) {
		read( handle , (char *)&zhead , sizeof( zhead ) );
		Head.base = zhead.base;
		Head.exec = zhead.base;
		Head.text = zhead.text;
		Head.data = zhead.data;
		Head.bss = zhead.bss;
		Head.symbol = 0;
		Head.bindinfo = 0;
		Absolute = ABSOLUTE_ZFILE;
	} else {
		read( handle , (char *)&Head , 64 );
		if( memcmp( Head.head , "HU\0\0" , 4 ) != 0 ) {
			close( handle );
			err( 1 , "̂悤ȃt@C͎舵Ă܂\n" );
		}
	}
#endif	/* OSKDIS	*/

	bytes = Head.text + Head.data + Head.offset + Head.symbol;

	if( ( top = (address)Malloc( bytes ) ) == NULL ) {
		close( handle );
		err( 1 , "%s[hobt@mۏo܂ł\n" , filename );
	}

	read( handle , (char*)top , bytes );
	close( handle );
	return top;
}


/*

  n

*/
extern void 	free_load_buffer()
{
	Mfree( (void*)Top );
}


/*

  foCXhCȍ

*/
private void	analyze_device()
{
#ifndef	OSKDIS
	ULONG		ad = 0;
	char		*pad;
	do {
		regist_label( Head.base + ad	   , DATLABEL | LONGSIZE | FORCE );
		regist_label( Head.base + ad + 4   , DATLABEL | WORDSIZE | FORCE );
		regist_label( Head.base + ad + 0xe , DATLABEL | STRING | FORCE );
		regist_label( Head.base + ad + 0x16, DATLABEL | UNKNOWN );
		Reason_verbose = ( Verbose >= 1 ? TRUE : FALSE );
		analyze( *(address*)( Ofst + ad + 6 ) , ANALYZE_IGNOREFAULT );
		analyze( *(address*)( Ofst + ad + 0xa ) , ANALYZE_IGNOREFAULT );
		pad = (char*)ad;
		ad = *(ULONG*)( pad + Ofst );
	} while( *(ULONG*)( pad + Ofst ) != 0xffffffff );
#endif	/* OSKDIS	*/
}







/*

  o̓t@C̑݃`FbN

*/
private void	check_exist_output_file( filename )
char	*filename;
{
	FILE	*fp;
	int		key;

	if( option_overwrite || !strcmp("-",filename) )
		return;


	if( ( fp = fopen( filename , "r" ) ) != NULL ) {
	if( isatty( fileno( fp ) ) ) {
		fclose( fp );
		return;
	}
	fprintf( stderr , "%s ɑ݂܂B\n" , filename );
	fprintf( stderr , "Over Write ( Y or N )? " );
	do {
		key = _dos_getc();
		fprintf(stderr,"%c",key);
		key = tolower( key );
	} while( key != 'y' && key != 'n' );
	fprintf( stderr , "\n" );
	fclose( fp );
	if( key == 'n' )
		exit( 1 );
	}
}



/*

  o̓t@Cɏ߂ǂ̃`FbN

*/
private void	check_open_output_file( filename )
char	*filename;
{
	int fd;

	if( !strcmp("-",filename) )
		return;


#ifdef	OSK
	if( ( fd = open( filename , S_IREAD ) ) < 0 ) {
		return;
	}
#else
	if( ( fd = open( filename , O_RDONLY ) ) < 0 ) {
		return;
	}
#endif	/* OSK	*/
	if( isatty( fd ) ) {
		close( fd );
		return;
	}
	close( fd );
	if( access( filename , R_OK | W_OK ) < 0 )
		err( 1 , "%s ɃANZXł܂(!)\n" , filename );
}

