/* $Id: offset.c,v 1.1 1996/11/07 08:03:52 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Ĕzue[uǗW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include	<stdio.h>
#include	"estruct.h"
#include	"global.h"
#include	"etc.h"
#include	"offset.h"

/* private ֐vg^Cv */
#ifdef	DEBUG
private void	disp_reltable( void );
#endif

static address	*Reltable = NULL;		/* Ĕzue[u̓ */
static int	Relnum;				/* Ĕzue[u̗vf */

/*#define	DEBUG*/


/*

  Ĕzue[uĔzuׂAhX̃e[u

*/
extern void	make_relocate_table()
{
    UBYTE	*ptr;		/* ItZbg\ւ̃|C^ ( not always even !) */
    address	destadrs = BeginTEXT;

    if( ( Reltable = (address *)Malloc( Head.offset * 2 ) ) == NULL )
	err( 1 , "P[g̓WJobt@mۏo܂ł\n" );

    Relnum = 0;
    ptr = (UBYTE*)( Top + Head.text + Head.data );
    while( ptr < (UBYTE*)( Top + Head.text + Head.data + Head.offset ) ) {
	if( ( *ptr << 8 ) + *( ptr + 1 ) != 0x0001 ) {
	    Reltable[ Relnum++ ] = destadrs = destadrs +
		(ULONG)(( *ptr << 8 )+ *( ptr + 1 ));
	    ptr += 2;
	} else {
	    ptr += 2;
	    Reltable[ Relnum++ ] = destadrs = destadrs +
		(ULONG)((*ptr << 24)+(*(ptr + 1) << 16)+(*(ptr + 2 ) << 8) + *(ptr + 3));
	    ptr += 4;
	}
    }
#ifdef	DEBUG
    disp_reltable();
#endif
}


/*

  n

*/
extern void	free_relocate_buffer()
{
    if( Reltable != NULL )
	Mfree( Reltable );
}


/*

  adrs vÕ[hꂽAhXɈˑĂȂ TRUE
  label1	pea.l	label2
  ̂Ƃ depend_address( label1 + 2 ) == TRUE  ( label2ˑĂ )

*/
extern boolean	depend_address( adrs )
address	adrs;
{
    int		step = Relnum >> 1;
    address	*ptr = Reltable;

    while( step > 4 ) {
	if( *( ptr + step ) <= adrs )			/* binary search */
	    ptr += step;
	step >>= 1;
    }
    for( ; ptr < Reltable + Relnum ; ptr++ ) {
	if( *ptr == adrs ) {
#ifdef	DEBUG
	    printf( "%6x is address-dependent\n" ,adrs );
#endif
	    return TRUE;
	} else
	    if( adrs < *ptr )
		return FALSE;
    }
    return FALSE;
}


/*

  adrs ŁAł߂AhXˑ̃AhXԂ
  ̂悤ȗ̈悪 0xffffffff = -1 Ԃ

*/
extern address	nearadrs( adrs )
address	adrs;
{
    address	rc = (address)-1;
    int		step;
    address	*ptr;

    step = Relnum >> 1;
    ptr = Reltable;
    while( step > 4 ) {
	if( *( ptr + step ) <= adrs )			/* binary search */
	    ptr += step;
	step >>= 1;
    }

    for( ; ptr < Reltable + Relnum ; ptr++ ) {
	if( *ptr >= adrs ) {
	    rc = *ptr;
	    break;
	}
    }

#ifdef 	DEBUG
    printf( "nearadrs (%x) = %x\n" , adrs , rc );
#endif
    return rc;
}


#ifdef	DEBUG
private void	disp_reltable()
{
    int		i;

    for( i = 0 ; i < Relnum ; i++ )
	printf( "%5x\n" , Reltable[ i ] );
}
#endif

