/* $Id: table.h,v 1.1 1996/10/24 04:27:50 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	e[uW[wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */


#define	EXPR_MAX_LENGTH		100
#define MAX_TABLE_NUM		256
#define MAX_TABLE_LINE		32

/*
  e[u̍\
  PAhXɂP table 
  table.formulaptr[ 0 ... table.lines - 1 ] e[ũoێĂ
*/

typedef struct _formula {
/*  int		count;*/	/* now, count is evaluated each time */
    opesize	id;
    boolean	hidden;
    int		line;
    char	expr[ EXPR_MAX_LENGTH ];
} formula;

typedef struct _table {
    address	tabletop;
    int		loop;
    int		lines;
    formula	*formulaptr;
} table;

extern void	read_tablefile( char* );
extern table	*search_table( address );

typedef enum {
    PARSE_ANALYZING ,
    PARSE_GENERATING ,
} parse_mode;
extern char		*Lexptr;
extern parse_mode	ParseMode;
extern int		Eval_Value;
extern address		Eval_TableTop;
extern address		Eval_PC;
extern int		Eval_Bytes;
extern opesize		Eval_ID;
extern int		Eval_Count;
extern int		Eval_Break;
extern opesize		Eval_SizeID;
extern char		Eval_ResultString[ 256 ];
